﻿var wmplayer;
var autoPlayed=false;
var isScrolling=false;
var scrollQueue=0;
var hasChannelLoaded=false;
var amountScrolled;

var kVersion=3;

plugin.onAddCustomMenuItems=AddCustomMenuItems;

options.defaultValue("volume")=50;
options.defaultValue("opacity") = 100;
options.defaultValue("feed") = 0;
options.defaultValue("channel") = -1;
options.defaultValue("auto_start") = false;
options.defaultValue("DontAskForThisUpdate")=0;

var nowPlayingBoxFullY=59;
var nowPlayingBoxFullHeight=202;

var nowPlayingBoxMiniY=193;
var nowPlayingBoxMiniHeight=68;

var channelBoxFullY=59;
var channelBoxFullHeight=202;

var channelBoxMiniY=59;
var channelBoxMiniHeight=126;

var listContainerFullHeight=177;
var listContainerMiniHeight=108;

var controlButtonsFullY=109;
var controlButtonsMiniY=7;

var backLinkFullY=172;
var backLinkMiniY=42;

var feedStreams;
var feedNames;
var feedIDs;
var feedURLs;

var curOpac=options("opacity");
var curChannel;
var curChannelID=options("channel");

function view_onOpen(){
wholePlugin.opacity=255*(curOpac/100);
ParseFeeds();
try{
    wmplayer=objWMP.object;
}catch(e){
    nowPlayingBox.y=nowPlayingBoxFullY;
    nowPlayingBox.height=nowPlayingBoxFullHeight;
    title.innerText=WMPERROR;
    headerChannels.opacity=0;
    headerNowPlaying.opacity=0;
    nowPlayingBox.visible=true;
    controlButtons.visible=false;
    backToChannels.visible=false;
    backToNowPlaying.visible=false;
    title.height=nowPlayingBox.height-(title.y*2);
    category.visible=false;
    program.visible=false;
    title.valign="top";
    adjustNowPlayingBackground();
    return;
}
wmplayer.settings.volume=options("volume");
if (curChannelID>0){
    nowPlayingBox.y=nowPlayingBoxFullY;
    nowPlayingBox.height=nowPlayingBoxFullHeight;
    backToChannels.opacity=255;
    backToNowPlaying.opacity=0;
    backToChannels.y=backLinkFullY;
    controlButtons.y=controlButtonsFullY;
    adjustNowPlayingBackground();
    headerChannels.opacity=0;
    headerNowPlaying.opacity=255;
	nowPlayingBox.visible=true;
	loadChannel();
	if (!options("auto_start"))
		autoPlayed=true;
}else{
    headerChannels.opacity=255;
    headerNowPlaying.opacity=0;
    
    channelBox.y=channelBoxFullY;
    channelBox.height=channelBoxFullHeight;
    
    progressScroll.thumbImage="images\\thumb.png";
    progressScroll.thumbDownImage="images\\thumb_down.png";
    progressScroll.thumbOverImage="images\\thumb_hot.png";
    
    listContainer.height=listContainerFullHeight;
    listContainer.y=(channelBox.height-listContainer.height)/2;
	doListMode();
	adjustChannelsBackground();
	channelBox.visible=true;
}
CheckForUpdates();
}

function openURL(url){
    var WinShell = new ActiveXObject("Shell.Application");
	WinShell.ShellExecute(url);
}

function openNPR(){
	openURL("http://www.npr.org");
}

function refresh(){
if (wmplayer.playState==3 && autoPlayed)
	wmplayer.controls.stop();

	next.enabled=wmplayer.controls.isAvailable('next');
	prev.enabled=wmplayer.controls.isAvailable('previous');
	stop.enabled=wmplayer.controls.isAvailable('stop');

	
	if (wmplayer.controls.isAvailable('pause'))
	{
		pause.enabled=true;
		pause.visible=true;
		play.visible=false;
	}else if (wmplayer.controls.isAvailable('play')){
		play.enabled=true;
		play.visible=true;
		pause.visible=false;
	}else{
		play.enabled=false;
		play.visible=true;
		pause.visible=false;
	}
	

	if (wmplayer.currentMedia && wmplayer.currentMedia.getItemInfo('artist')!=""){
		updatePosition();
	}else {
		program.innerText="";
		var status=wmplayer.status;
		if (status=="")
			status=LOADING;
		title.innerText=status;
	}
}

function updatePosition(){
	var artist=wmplayer.currentMedia.getItemInfo('artist');
	if (artist.substring(0,5)=="NPR's")
		artist=artist.substring(6);

	program.innerText=artist;
	title.innerText=wmplayer.currentMedia.getItemInfo('title');

	program.tooltip=program.innerText;
	title.tooltip=title.innerText;
}

function Play(){
	autoPlayed=false;
	wmplayer.controls.play();
}

function Pause(){
	wmplayer.controls.pause();
}

function Next(){
	wmplayer.controls.next();
}

function Prev(){
try{
    if (wmplayer.controls.currentPosition>3)
     {
        wmplayer.controls.currentPosition=0;
        return;
     }
}catch(e){
}
wmplayer.controls.previous();
}

function Stop(){
	wmplayer.controls.stop();
}

function view_onClose(){
try{
	wmplayer.close();
} catch(e){}
}

function AddCustomMenuItems(menu){
	menu.AddItem(AUTO_START,options("auto_start")?gddMenuItemFlagChecked:0,onChangeAutoStart);
	menu.AddItem("",0,0);


      var feedMenu=menu.AddPopup(CHANNEL);
      for(var i=0;i<feedStreams.length;i++)
          feedMenu.AddItem(feedNames[i].replace("&","&&"), (i==curChannel)?gddMenuItemFlagChecked:0, onChannelChange);

	menu.AddItem("",0,0);

      var volumeMenu=menu.AddPopup(VOLUME);
      var curVol=Math.round(wmplayer.settings.volume/10,0)*10;
	
	volumeMenu.AddItem(MUTE,wmplayer.settings.mute?gddMenuItemFlagChecked:0,onMuteChange);

	volumeMenu.AddItem("",0,0);
      for(var i=10;i<=100;i+=10)
          volumeMenu.AddItem("&" + i + "", (i==curVol)?gddMenuItemFlagChecked:0, onVolumeChange);

	menu.AddItem("",0,0);

      var opacityMenu=menu.AddPopup(OPACITY);
      for(var i=10;i<=100;i+=10)
          opacityMenu.AddItem("&" + i + "%", (i==curOpac)?gddMenuItemFlagChecked:0, onOpacityChange);
}

function onOpacityChange(newOpacity){
    curOpac=parseInt(newOpacity.replace("&",""));
    options("opacity")=curOpac;
    wholePlugin.opacity=255*(curOpac/100);
}

function onVolumeChange(newVolume){
    var curVol=parseInt(newVolume.replace("&",""));
    options("volume")=curVol;
    wmplayer.settings.volume=curVol;
}

function onMuteChange(){
wmplayer.settings.mute=!wmplayer.settings.mute;
}

function ParseFeeds(){
var feeds=gadget.storage.openText("channels.xml");
var DOMDoc=new DOMDocument();
DOMDoc.loadXML(feeds);
var Categories = DOMDoc.getElementsByTagName("category");
feedStreams=new Array();
feedURLs=new Array();
feedIDs=new Array();
feedNames=new Array();
for (var i=0;i<Categories.length;i++){
	feedStreams[i]=Categories[i].getElementsByTagName("audioURL")[0].text;
	feedURLs[i]=Categories[i].getElementsByTagName("webURL")[0].text;
	feedIDs[i]=Categories[i].getElementsByTagName("id")[0].text;
	feedNames[i]=Categories[i].getElementsByTagName("name")[0].text;
	if (feedIDs[i]==curChannelID)
		curChannel=i;
}
}

function onChannelChange(newChannel){
for(var i=0;i<feedStreams.length;i++){
	if (feedNames[i].replace("&","&&")==newChannel){
		curChannel=i;
		curChannelID=feedIDs[i];
		break;
	}
}

    nowPlayingBox.y=nowPlayingBoxFullY;
    nowPlayingBox.height=nowPlayingBoxFullHeight;
    backToChannels.opacity=255;
    backToNowPlaying.opacity=0;
    backToChannels.y=backLinkFullY;
    controlButtons.y=controlButtonsFullY;
    adjustNowPlayingBackground();
    headerChannels.opacity=0;
    headerNowPlaying.opacity=255;
	nowPlayingBox.visible=true;
	loadChannel();
	headerChannels.opacity=0;
	channelBox.opacity=0;
	nowPlayingBox.opacity=255;
}



function loadListChannel(channelID){
for(var i=0;i<feedStreams.length;i++){
	if (feedIDs[i]==channelID){
		curChannel=i;
		curChannelID=feedIDs[i];
		break;
	}
}
if (hasChannelLoaded){
    Hide(headerChannels,350);
    Show(headerNowPlaying,350);
    Hide2 (channelBox,backToNowPlaying,200,"loadListChannel2();");
}else{
    loadChannel();
      
    nowPlayingBox.y=nowPlayingBoxFullY;
    nowPlayingBox.height=nowPlayingBoxFullHeight;
    nowPlayingText.opacity=255;
    adjustNowPlayingBackground();
    
    controlButtons.y=controlButtonsFullY;
    controlButtons.y=controlButtonsFullY;
    backToChannels.opacity=255;
    backToNowPlaying.opacity=0;
    backToChannels.y=backLinkFullY;
    
    nowPlayingBox.opacity=0;
	nowPlayingBox.visible=true;
	
    Hide2(channelBox,headerChannels,350);
    Show2(nowPlayingBox,headerNowPlaying,350);
}
}

function loadListChannel2(){

	beginAnimation("nowPlayingBox.height+=nowPlayingBox.y-event.value;nowPlayingBox.y=event.value;adjustNowPlayingBackground();if((controlButtons.y+nowPlayingBox.y)<(nowPlayingBoxFullY+controlButtonsFullY))controlButtons.y=(nowPlayingBoxFullY+controlButtonsFullY)-nowPlayingBox.y;if(nowPlayingBox.y==nowPlayingBoxFullY) { loadChannel();backToChannels.y=backLinkFullY;Show2(backToChannels,nowPlayingText,200)}",nowPlayingBox.y,nowPlayingBoxFullY,250);
}

function loadChannel(){
    hasChannelLoaded=true;
	options("channel")=curChannelID;
	category.innerText=CATEGORY.replace("%1",feedNames[curChannel] );
	category.tooltip=category.innerText;
	category.href=feedURLs[curChannel];
	wmplayer.URL=feedStreams[curChannel];
	autoPlayed=false;
}

function doListMode(){
if (listTarget.children.count>0)
    return;
var total=feedStreams.length;
listTarget.height=(feedStreams.length*23)-7;
for(var i=0;i<feedStreams.length;i++){
    var theElement=	listTarget.appendElement('<a height="16" x="0" y="' + i*23 + '" font="arial" size="10" align="left" color="#0021b6" overcolor="#0048ff" trimming="character-ellipsis" onclick="loadListChannel('+ feedIDs[i] +')" />')
    theElement.tooltip=LISTTOOLTIP.replace("%1",feedNames[i]);
    theElement.innerText=feedNames[i];
}
}

function Show(element, time, done){
	beginAnimation(element.name + ".opacity=event.value;" + ((done!="")?("if(event.value==255) {" + done + "}"):("")),element.opacity,255,time);
}

function Hide(element, time, done){
	beginAnimation(element.name + ".opacity=event.value;" + ((done!="")?("if(event.value==0) {" + done + "}"):("")),element.opacity,0,time);
}

function Show2(element1, element2, time, done){
	beginAnimation(element1.name + ".opacity=event.value;" + element2.name + ".opacity=event.value;" + ((done!="")?("if(event.value==255) {" + done + "}"):("")),element1.opacity,255,time);
}

function Show3(element1, element2, element3, time, done){
	beginAnimation(element1.name + ".opacity=event.value;" + element2.name + ".opacity=event.value;" + element3.name + ".opacity=event.value;" + ((done!="")?("if(event.value==255) {" + done + "}"):("")),element1.opacity,255,time);
}

function Hide2(element1, element2, time, done){
	beginAnimation(element1.name + ".opacity=event.value;" + element2.name + ".opacity=event.value;" + ((done!="")?("if(event.value==0) {" + done + "}"):("")),element1.opacity,0,time);
}

function MoveY(element, start, end, time, done){
	beginAnimation(element.name + ".y=event.value;" + ((done!="")?("if(event.value==" + end + ") {" + done + "}"):("")),start,end,time);
}

function MoveY(element, start, end, time, done){
	beginAnimation(element.name + ".y=event.value;" + ((done!="")?("if(event.value==" + end + ") {" + done + "}"):("")),start,end,time);
}

function onChangeAutoStart(){
options("auto_start")=!options("auto_start");
}


function backToChannelBrowser(channelID){
    channelBox.opacity=0;
    channelBox.visible=true;
    channelBox.y=channelBoxMiniY;
    channelBox.height=channelBoxMiniHeight;
    progressScroll.thumbImage="images\\minithumb.png";
    progressScroll.thumbDownImage="images\\minithumb_down.png";
    progressScroll.thumbOverImage="images\\minithumb_hot.png";
    listContainer.height=listContainerMiniHeight;
    listContainer.y=(channelBox.height-listContainer.height)/2;
	doListMode();
    adjustChannelsBackground();


    backToNowPlaying.y=backLinkMiniY;


Hide2 (nowPlayingText,backToChannels,200,"backToChannelBrowser2();");
}

function backToChannelBrowser2(){
	beginAnimation("nowPlayingBox.height+=nowPlayingBox.y-event.value;nowPlayingBox.y=event.value;adjustNowPlayingBackground();if((controlButtons.y+nowPlayingBox.y)>(nowPlayingBoxMiniY+controlButtonsMiniY))controlButtons.y=(nowPlayingBoxMiniY+controlButtonsMiniY)-nowPlayingBox.y;if(nowPlayingBox.y==nowPlayingBoxMiniY) { backToChannels.y=backLinkMiniY;Hide(headerNowPlaying,350);Show3(backToNowPlaying,channelBox,headerChannels,350)}",nowPlayingBox.y,nowPlayingBoxMiniY,250);
}

function backToNowPlayingInfo(channelID){

Hide(headerChannels,350);
Show(headerNowPlaying,350);
Hide2 (channelBox,backToNowPlaying,200,"backToNowPlayingInfo2();");
}

function backToNowPlayingInfo2(){

	beginAnimation("nowPlayingBox.height+=nowPlayingBox.y-event.value;nowPlayingBox.y=event.value;adjustNowPlayingBackground();if((controlButtons.y+nowPlayingBox.y)<(nowPlayingBoxFullY+controlButtonsFullY))controlButtons.y=(nowPlayingBoxFullY+controlButtonsFullY)-nowPlayingBox.y;if(nowPlayingBox.y==nowPlayingBoxFullY) { backToChannels.y=backLinkFullY;Show2(backToChannels,nowPlayingText,200)}",nowPlayingBox.y,nowPlayingBoxFullY,250);
}

function adjustNowPlayingBackground(){
npbBtm.y=nowPlayingBox.height-7;
npbMdl.height=nowPlayingBox.height-14;
}

function adjustChannelsBackground(){
cbBtm.y=channelBox.height-7;
cbMdl.height=channelBox.height-14;
scrollBar.height=channelBox.height-(scrollBar.y*2);
progressScroll.min=0;
progressScroll.max=(listTarget.height-listContainer.height);
progressScroll.value=progressScroll.max;
progressScroll.height=scrollBar.height-(progressScroll.y*2); //subtract the height of the up/down buttons
scrollDown.y=progressScroll.height + progressScroll.y;
scrollBG.height=progressScroll.height;
}

function DownloadClass(onDone,url, postData, onError){
	var http = new XMLHttpRequest();
	http.onreadystatechange = OnData;
	this.DownloadPage=DownloadPage;
	function DownloadPage(){	
		if (postData){
			http.open("POST", url, true);
			http.setRequestHeader('Content-Type',
			'application/x-www-form-urlencoded');
			http.send(postData);
		}else{
			http.open("GET", url, true);
			http.send();
		}
	}
	function OnData() {
		if (http.readyState == 4) { // completed?
			if (http.status==200){
				var dlText=http.responseText;
				onDone(dlText);
			}
			http=null;

		}
	}
}

function handleScroll(){
    listTarget.y=progressScroll.value-progressScroll.max;

        
}


function scrollItUp(){
amountScrolled=0;
beginAnimation("goUp(event.value-amountScrolled); if (event.value==23)HandleMoreScrolling();",0,23,100);
HandleMoreScrolling()
}

function goUp(x){
amountScrolled+=x;
if (progressScroll.value+x>progressScroll.max)
    progressScroll.value=progressScroll.max;
else
    progressScroll.value+=x;
}

function scrollItDown(){
amountScrolled=0;
beginAnimation("goDown(event.value-amountScrolled); if (event.value==23)HandleMoreScrolling();",0,23,100);
}

function goDown(x){
amountScrolled+=x;
if (progressScroll.value-x<progressScroll.min)
    progressScroll.value=progressScroll.min;
else
    progressScroll.value-=x;
}

function up(){
if (isScrolling)
	scrollQueue++;
else{
	isScrolling=true;
	scrollItUp();
}
}

function down(){
if (isScrolling)
	scrollQueue--;
else{
	isScrolling=true;
	scrollItDown();
}
}

function HandleMoreScrolling(){
isScrolling=false;
if (scrollQueue>0 && progressScroll.value<progressScroll.max){ //we're scrolling up{
	scrollQueue--;
	up();
}
else if (scrollQueue<0 && progressScroll.value>progressScroll.min){ //we're scrolling down
	scrollQueue++;
	down();
}
}

function CheckForUpdates(){
	    var dlClass=new DownloadClass(HandleUpdate,"http://www.npr.org/gadget/update.xml?Log=1&imp=gg&rnd=" + Math.random() + "&LANGID",null,false);
	    dlClass.DownloadPage();
	    dlClass=null;
    	
	    function HandleUpdate(text){
            var DOMDoc=new DOMDocument();
            if (DOMDoc.loadXML(text)){
                  var UpdateTree = DOMDoc.getElementsByTagName("update");
                  var LatestVersion = (UpdateTree[0].getElementsByTagName("latestversion")[0].text);
                  var Message = UpdateTree[0].getElementsByTagName("message")[0].text;
                  var URL = UpdateTree[0].getElementsByTagName("url")[0].text;
                  
                  if (LatestVersion>kVersion && LatestVersion>options("DontAskForThisUpdate")) {
                        options("DontAskForThisUpdate")=LatestVersion;
                        if(confirm(Message)){
                            var WinShell = new ActiveXObject("Shell.Application");
                            WinShell.ShellExecute(URL);
                        }
                  }
            }
        }
}

function findLocal(){
openURL("http://www.npr.org/stations");
}